#
# File: CompilerFlags.cmake
#
# Date: Thu Apr 20 13:25:00 EST 2017
# Author: manuel.arguelles
#
# Copyright 2017 Smartmatic Corp. All Rights Reserved.
#
# Confidential Information of Smartmatic Labs. Not for disclosure or distribution
# prior written consent. This software contains code, techniques and know-how which
# is confidential and proprietary to Smartmatic.
#
# Use of this software is subject to the terms of an end user license agreement.
#
# Sets the flags for the compiler

# Global c compilerflags
IF ("${CMAKE_C_COMPILER_ID}" STREQUAL "GNU")
  SET (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pedantic -Wall -Wchar-subscripts -Wcast-align -Wcomment -Wctor-dtor-privacy -Wdisabled-optimization")
  SET (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wformat -Wformat=2 -Wformat-nonliteral -Wformat-security -Wformat-y2k -Wimport -Winit-self -Winvalid-pch")
  SET (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wlogical-op -Wpacked -Wpointer-arith -Wmissing-braces -Wmissing-declarations -Wmissing-field-initializers")
  SET (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wmissing-format-attribute -Wsequence-point -Wswitch-enum -Wsign-promo")
  SET (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wsign-compare -Wstrict-aliasing -Wstrict-null-sentinel -Wtrigraphs -Wreturn-type -Wunused-function -Wunused")
  SET (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wuninitialized -Wundef -Wunused-label -Wunused-value -Wunused-variable -Wunknown-pragmas -Wvariadic-macros")
  SET (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wvolatile-register-var -Wunknown-pragmas -Wvariadic-macros -Wvolatile-register-var -Wwrite-strings -Wparentheses")
  SET (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wextra -Werror -Wno-unused-parameter -Wno-long-long -Wno-unused-result")
ELSE()
  SET (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")
ENDIF()

# Global c++ cmpiler
IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
  SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pedantic -Wall -Wchar-subscripts -Wcast-align -Wcomment -Wctor-dtor-privacy -Wdisabled-optimization")
  SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wformat -Wformat=2 -Wformat-nonliteral -Wformat-security -Wformat-y2k -Wimport -Winit-self -Winvalid-pch")
  SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wlogical-op -Wpacked -Wpointer-arith -Wmissing-braces -Wmissing-declarations -Wmissing-field-initializers")
  SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wmissing-format-attribute -Wsequence-point -Wswitch-enum -Wsign-promo")
  SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wsign-compare -Wstrict-aliasing -Wstrict-null-sentinel -Wtrigraphs -Wreturn-type -Wunused-function -Wunused")
  SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wuninitialized -Wundef -Wunused-label -Wunused-value -Wunused-variable -Wunknown-pragmas -Wvariadic-macros")
  SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wvolatile-register-var -Wunknown-pragmas -Wvariadic-macros -Wvolatile-register-var -Wwrite-strings -Wparentheses")
  SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wextra -Werror -Wno-unused-parameter -Wno-long-long -Wno-unused-result")
ELSE()
  SET (CMAKE_C_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
ENDIF()

# Release flags
set(CMAKE_C_FLAGS_RELEASE "-O3 -DNDEBUG -s")
set(CMAKE_CXX_FLAGS_RELEASE "-O3 -DNDEBUG -s")

# Debug flags
set(CMAKE_C_FLAGS_DEBUG "-g -O0 -fprofile-arcs -ftest-coverage")
set(CMAKE_CXX_FLAGS_DEBUG "-g -O0 -fprofile-arcs -ftest-coverage")


