#
# File: FindLibUsb.cmake
#
# Date: Mon Jul 15 11:21:00 EST 2013
# Author: andres.sanchez
#
# Copyright 2012 Smartmatic Corp. All Rights Reserved.
#
# Confidential Information of Smartmatic Labs. Not for disclosure or distribution
# prior written consent. This software contains code, techniques and know-how which
# is confidential and proprietary to Smartmatic.
#
# Use of this software is subject to the terms of an end user license agreement.
#
# Try to find libUSB library
# Once done this will define
#
# LIBUSB_FOUND        - if false, do not try to link to libusb-1.0
# LIBUSB_LIBRARIES    - the library to link against
# LIBUSB_INCLUDE_DIRS - where to find headers.
#

INCLUDE (FindPackageHandleStandardArgs)

FIND_PATH (
  LIBUSB_INCLUDE_DIRS
  NAMES libusb.h
  PATHS
    /usr/include
    /usr/local/include
    /opt/local/include
    /sw/include
  PATH_SUFFIXES
    libusb-1.0
)

FIND_LIBRARY (
  LIBUSB_LIBRARIES
  NAMES libusb-1.0 usb-1.0
  PATHS
    /lib
    /usr/lib
    /usr/local/lib
    /opt/local/lib
    /sw/lib
)

FIND_PACKAGE_HANDLE_STANDARD_ARGS (LibUsb REQUIRED_VARS LIBUSB_LIBRARIES LIBUSB_INCLUDE_DIRS)

MARK_AS_ADVANCED (LIBUSB_LIBRARIES LIBUSB_INCLUDE_DIRS)
