#
# File: FindLibsmartmaticgui.cmake
#
# Date: Fri Tue 21 17:23:00 EST 2017
# Author: gustavo.garcia
#
# Copyright 2014 Smartmatic Corp. All Rights Reserved.
#
# Confidential Information of Smartmatic Labs. Not for disclosure or distribution
# prior written consent. This software contains code, techniques and know-how which
# is confidential and proprietary to Smartmatic.
#
# Use of this software is subject to the terms of an end user license agreement.
#
# Try to find smartmaticgui library
# Once done this will define
#
# LIBSMTT_GUI_FOUND        - True if libsmartmaticgui got found
# LIBSMTT_GUI_INCLUDE_DIRS - Location of libsmartmaticgui headers
# LIBSMTT_GUI_LIBRARIES    - List of libraries to use libsmartmaticgui
#

INCLUDE (FindPackageHandleStandardArgs)

FIND_PATH (
  LIBSMTT_GUI_INCLUDE_DIRS
  NAMES Operation/WindowsManager.hxx
  PATHS
    ${CMAKE_INSTALL_PREFIX}/include/smartmaticgui
    ${WORKSPACE_PATH}/include/smartmaticgui
)

FIND_LIBRARY (
  LIBSMTT_GUI_LIBRARY
  NAMES libsmartmaticgui.so
  PATHS
    ${CMAKE_INSTALL_PREFIX}/lib
    ${WORKSPACE_PATH}/lib
)

FIND_PACKAGE_HANDLE_STANDARD_ARGS (LIBSMTT_GUI REQUIRED_VARS LIBSMTT_GUI_LIBRARY LIBSMTT_GUI_INCLUDE_DIRS)

MARK_AS_ADVANCED (LIBSMTT_GUI_LIBRARY LIBSMTT_GUI_INCLUDE_DIRS)
