#
# File: Findglibmm.cmake
#
# Date: Fri Jan 03 12:00:00 EST 2017
# Author: gustavo.garcia
#
# Copyright 2012 Smartmatic Corp. All Rights Reserved.
#
# Confidential Information of Smartmatic Labs. Not for disclosure or distribution
# prior written consent. This software contains code, techniques and know-how which
# is confidential and proprietary to Smartmatic.
#
# Use of this software is subject to the terms of an end user license agreement.
#
# Try to find glibmm library
# It sets the following variables:
#
#  glibmm_INCLUDE_DIR        - The glibmm include directory.
#  glibmm_config_INCLUDE_DIR - The glibmm configuration include directory.
#  glibmm_LIBRARY            - The glibmm library to link against.
#


INCLUDE (FindPackageHandleStandardArgs)

IF(glibmm_FIND_REQUIRED)
  FIND_PACKAGE(glib    REQUIRED)
  FIND_PACKAGE(gobject REQUIRED)
  FIND_PACKAGE(sigc++  REQUIRED)
ENDIF(glibmm_FIND_REQUIRED)


#use pkg-config
FIND_PACKAGE(PkgConfig)
PKG_CHECK_MODULES(PC_GLIBMM glibmm-2.4)

FIND_PATH(glibmm_INCLUDE_DIR NAMES glibmm/main.h HINTS ${PC_GLIBMM_INCLUDEDIR} ${PC_GLIBMM_INCLUDE_DIRS})
FIND_PATH(glibmm_config_INCLUDE_DIR NAMES glibmmconfig.h HINTS ${PC_GLIBMM_INCLUDEDIR} ${PC_GLIBMM_INCLUDE_DIRS})

FIND_LIBRARY(glibmm_LIBRARY NAMES glibmm glibmm-2.4 HINTS ${PC_GLIBMM_LIBDIR} ${PC_GLIBMM_LIBRARY_DIRS})

SET(glibmm_LIBRARIES ${glibmm_LIBRARY} ${PC_GLIBMM_PKGCONF_LIBRARIES} ${glib_LIBRARIES} ${sigc++_LIBRARIES})
SET(glibmm_INCLUDE_DIRS ${glibmm_INCLUDE_DIR} ${glibmm_config_INCLUDE_DIR} ${PC_GLIBMM_PKGCONF_INCLUDE_DIRS} ${glib_INCLUDE_DIRS} ${sigc++_INCLUDE_DIRS})


FIND_PACKAGE_HANDLE_STANDARD_ARGS(glibmm REQUIRED_VARS glibmm_LIBRARY glibmm_INCLUDE_DIR)
MARK_AS_ADVANCED(glibmm_INCLUDE_DIR glibmm_config_INCLUDE_DIR glibmm_LIBRARY)

